// Copyright (C) 1991 - 1999 Rational Software Corporation

#include "stdafx.h"
#include "InventoryServices.h"
#include "CProduct.h"
#include <comdef.h>


//##ModelId=37DC1C710354
STDMETHODIMP CProduct::get_ProductSKU(long* sku)
{
	*sku = m_productSKU;
	return S_OK;
}

//##ModelId=37DC1C71038F
STDMETHODIMP CProduct::put_ProductSKU(long sku)
{
	m_productSKU = sku;
	return S_OK;
}

//##ModelId=37DC1C710391
STDMETHODIMP CProduct::get_Composer(BSTR* aComposer)
{
	CComBSTR composer( (char*) m_composer);
	*aComposer = composer.Copy();
	return S_OK;
}

//##ModelId=37DC1C710393
STDMETHODIMP CProduct::put_Composer(BSTR aComposer)
{
	SysReAllocString(&m_composer, aComposer);
	return S_OK;
}

//##ModelId=37DC1C7103C0
STDMETHODIMP CProduct::get_Composition(BSTR* aComposition)
{
	CComBSTR composition( (char*) m_composition);
	*aComposition = composition.Copy();
	return S_OK;
}

//##ModelId=37DC1C7103C2
STDMETHODIMP CProduct::put_Composition(BSTR aComposition)
{
	SysReAllocString(&m_composition, aComposition);
	return S_OK;
}

//##ModelId=37DC1C7103C4
STDMETHODIMP CProduct::get_Conductor(BSTR* aConductor)
{
	CComBSTR conductor( (char*) m_conductor);
	*aConductor = conductor.Copy();
	return S_OK;
}

//##ModelId=37DC1C7103C6
STDMETHODIMP CProduct::put_Conductor(BSTR aConductor)
{
	SysReAllocString(&m_conductor, aConductor);
	return S_OK;
}

//##ModelId=37DC1C720014
STDMETHODIMP CProduct::get_Performer(BSTR* aPerformer)
{
	CComBSTR performer( (char*) m_performer);
	*aPerformer = performer.Copy();
	return S_OK;
}

//##ModelId=37DC1C720016
STDMETHODIMP CProduct::put_Performer(BSTR aPerformer)
{
	SysReAllocString(&m_performer, aPerformer);
	return S_OK;
}

//##ModelId=37DC1C720018
STDMETHODIMP CProduct::get_Description(BSTR* aDescription)
{
	CComBSTR description( (char*) m_description);
	*aDescription = description.Copy();
	return S_OK;
}

//##ModelId=37DC1C720046
STDMETHODIMP CProduct::put_Description(BSTR aDescription)
{
	SysReAllocString(&m_description, aDescription);
	return S_OK;
}

//##ModelId=37DC1C720048
STDMETHODIMP CProduct::get_Image(BSTR* anImage)
{
	CComBSTR image( (char*) m_image);
	*anImage = image.Copy();
	return S_OK;
}

//##ModelId=37DC1C72004A
STDMETHODIMP CProduct::put_Image(BSTR anImage)
{
	SysReAllocString(&m_image, anImage);
	return S_OK;
}

//##ModelId=37DC1C72004C
STDMETHODIMP CProduct::get_Price(CURRENCY* aPrice)
{
	aPrice->Hi = m_price.Hi;
	aPrice->Lo = m_price.Lo;
	aPrice->int64 = m_price.int64;
	return S_OK;
}

//##ModelId=37DC1C720082
STDMETHODIMP CProduct::put_Price(CURRENCY aPrice)
{
	m_price.Hi = aPrice.Hi;
	m_price.Lo = aPrice.Lo;
	m_price.int64 = aPrice.int64;
	return S_OK;
}

