// Copyright (C) 1991 - 1999 Rational Software Corporation

#if defined (_MSC_VER) && (_MSC_VER >= 1000)
#pragma once
#endif
#ifndef _INC_CPRODUCTINVENTORY_37DC1C7D0226_INCLUDED
#define _INC_CPRODUCTINVENTORY_37DC1C7D0226_INCLUDED

#include "resource.h"

//##ModelId=37DC1C7D0226
class ATL_NO_VTABLE CProductInventory 
: public CComObjectRootEx<CComSingleThreadModel>
, public CComCoClass<CProductInventory,&CLSID_ProductInventory>
, public IDispatchImpl<IProductInventory,&IID_IProductInventory,&LIBID_INVENTORYSERVICESLib>
{
public:
	//##ModelId=37DC1C7D0304
	STDMETHOD (GetProduct)(long sku, IProduct** aProduct);

	//##ModelId=37DC1C7D033E
	STDMETHOD (AddProduct)(IProduct* aProduct);

	//##ModelId=37DC1C7D0340
	STDMETHOD (RemoveProduct)(long sku);

	//##ModelId=37DC1C7D0342
	STDMETHOD (UpdateProduct)(IProduct* aProduct);

public:
DECLARE_REGISTRY_RESOURCEID(IDR_PRODUCTINVENTORY)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CProductInventory)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IProductInventory)
END_COM_MAP()

};

#endif /* _INC_CPRODUCTINVENTORY_37DC1C7D0226_INCLUDED */

