VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "POSLineItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"37DC4F85005A"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Class Module"
Option Explicit

'##ModelId=37DC51180014
Implements ISalesLineItem

'##ModelId=37DC4FA10104
Private SalesLineItem As Long

'##ModelId=37DC4FAB01A4
Private mQuantity As Integer

'##ModelId=37DC4FBA008C
Private mSellingPrice As Currency

'##ModelId=37DC50B90302
Private moverriddenBy As IClerk

'##ModelId=37DC512F008C
Private mtheProduct As IProduct

'##ModelId=37DC4FD0003C
Public Function total() As Currency
    total = SellingPrice * Quantity
End Function

'##ModelId=37DC4FD50186
Public Sub SetSellingPrice(aPrice As Currency, overriddenBy As IClerk)
If overriddenBy Is Nothing Then
        mSellingPrice = theProduct.Price
    Else
        mSellingPrice = aPrice
        Set moverriddenBy = overriddenBy
    End If
End Sub

'##ModelId=37DC4FFF0316
Public Function Description() As String
    Dim descr As String
    
    descr = "[" & Quantity & "] " & theProduct.ProductSKU & " " & theProduct.Composer & " " & theProduct.Composition & " (" & FormatCurrency(SellingPrice) & ")"
    Description = descr
End Function

'##ModelId=37DC51BD01FE
Private Property Get ISalesLineItem_SalesLineItemID() As Long
    '## Your code goes here ...
End Property

'##ModelId=37DC51BD029E
Private Property Let ISalesLineItem_SalesLineItemID(ByVal SalesLineItemID As Long)
    '## Your code goes here ...
End Property

'##ModelId=37DC51BD037A
Private Property Get ISalesLineItem_SKU() As Long
    If Not theProduct Is Nothing Then
        ISalesLineItem_SKU = theProduct.ProductSKU
    End If
End Property

'##ModelId=37DC51BE003C
Private Property Let ISalesLineItem_SKU(ByVal SKU As Long)
    '## Your code goes here ...
End Property

'##ModelId=37DC51BE014A
Private Property Get ISalesLineItem_Quantity() As Long
    '## Your code goes here ...
End Property

'##ModelId=37DC51BE01B8
Private Property Let ISalesLineItem_Quantity(ByVal Quantity As Long)
    '## Your code goes here ...
End Property

'##ModelId=37DC51BE0302
Private Property Get ISalesLineItem_SellingPrice() As Currency
    '## Your code goes here ...
End Property

'##ModelId=37DC51BE0370
Private Property Let ISalesLineItem_SellingPrice(ByVal SellingPrice As Currency)
    '## Your code goes here ...
End Property

'##ModelId=37DC51BF00D2
Private Property Get ISalesLineItem_ManagerID() As Long
    If Not overriddenBy Is Nothing Then
        ISalesLineItem_ManagerID = overriddenBy.ClerkID
    End If
End Property

'##ModelId=37DC51BF017C
Private Property Let ISalesLineItem_ManagerID(ByVal ManagerID As Long)
    '## Your code goes here ...
End Property

'##ModelId=37DC51C00138
Private Sub Class_Initialize()
    Quantity = 1
    Set moverriddenBy = Nothing
    Set mtheProduct = Nothing
End Sub

'##ModelId=37DC51C001E6
Public Property Get Quantity() As Integer
    '## Generated default body ...
    Quantity = mQuantity
End Property

'##ModelId=37DC51C001E7
Public Property Let Quantity(ByVal vNewValue As Integer)
    '## Generated default body ...
    mQuantity = vNewValue
End Property

'##ModelId=37DC51C001EB
Public Property Get SellingPrice() As Currency
    '## Generated default body ...
    SellingPrice = mSellingPrice
End Property

'##ModelId=37DC51C001F0
Public Property Get overriddenBy() As IClerk
    '## Generated default body ...
    Set overriddenBy = moverriddenBy
End Property

'##ModelId=37DC51C001F5
Public Property Get theProduct() As IProduct
    '## Generated default body ...
    Set theProduct = mtheProduct
End Property

'##ModelId=37DC51C001F8
Public Property Set theProduct(ByVal vNewValue As IProduct)
    Set mtheProduct = vNewValue
    mSellingPrice = mtheProduct.Price
End Property
