// Copyright (C) 1991 - 1999 Rational Software Corporation

#if defined (_MSC_VER) && (_MSC_VER >= 1000)
#pragma once
#endif
#ifndef _INC_CPRODUCT_37DC1C710244_INCLUDED
#define _INC_CPRODUCT_37DC1C710244_INCLUDED

#include "resource.h"

//##ModelId=37DC1C710244
class ATL_NO_VTABLE CProduct 
: public CComObjectRootEx<CComSingleThreadModel>
, public CComCoClass<CProduct,&CLSID_Product>
, public IDispatchImpl<IProduct,&IID_IProduct,&LIBID_INVENTORYSERVICESLib>
{
private:	
	//##ModelId=37DC44060195
	CURRENCY m_price;	
	//##ModelId=37DC44060190
	BSTR m_performer;	
	//##ModelId=37DC4406015B
	BSTR m_image;	
	//##ModelId=37DC44060156
	BSTR m_description;	
	//##ModelId=37DC44060129
	BSTR m_conductor;	
	//##ModelId=37DC44060124
	BSTR m_composition;	
	//##ModelId=37DC44060049
	long m_productSKU;	
	//##ModelId=37DC44060046
	BSTR m_composer;

public:
	//##ModelId=37DC1C710354
	STDMETHOD (get_ProductSKU)(long* sku);

	//##ModelId=37DC1C71038F
	STDMETHOD (put_ProductSKU)(long sku);

	//##ModelId=37DC1C710391
	STDMETHOD (get_Composer)(BSTR* aComposer);

	//##ModelId=37DC1C710393
	STDMETHOD (put_Composer)(BSTR aComposer);

	//##ModelId=37DC1C7103C0
	STDMETHOD (get_Composition)(BSTR* aComposition);

	//##ModelId=37DC1C7103C2
	STDMETHOD (put_Composition)(BSTR aComposition);

	//##ModelId=37DC1C7103C4
	STDMETHOD (get_Conductor)(BSTR* aConductor);

	//##ModelId=37DC1C7103C6
	STDMETHOD (put_Conductor)(BSTR aConductor);

	//##ModelId=37DC1C720014
	STDMETHOD (get_Performer)(BSTR* aPerformer);

	//##ModelId=37DC1C720016
	STDMETHOD (put_Performer)(BSTR aPerformer);

	//##ModelId=37DC1C720018
	STDMETHOD (get_Description)(BSTR* aDescription);

	//##ModelId=37DC1C720046
	STDMETHOD (put_Description)(BSTR aDescription);

	//##ModelId=37DC1C720048
	STDMETHOD (get_Image)(BSTR* anImage);

	//##ModelId=37DC1C72004A
	STDMETHOD (put_Image)(BSTR anImage);

	//##ModelId=37DC1C72004C
	STDMETHOD (get_Price)(CURRENCY* aPrice);

	//##ModelId=37DC1C720082
	STDMETHOD (put_Price)(CURRENCY aPrice);

public:
DECLARE_REGISTRY_RESOURCEID(IDR_PRODUCT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CProduct)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IProduct)
END_COM_MAP()

};

#endif /* _INC_CPRODUCT_37DC1C710244_INCLUDED */

