// Copyright (C) 1991 - 1999 Rational Software Corporation

#include "stdafx.h"
#include "InventoryServices.h"
#include "CProductInventory.h"

#include "ProductRecord.h"
#include "CProduct.h"


//##ModelId=37DC1C7D0304
STDMETHODIMP CProductInventory::GetProduct(long sku, IProduct** aProduct)
{
	CProductRecord products;	
	CComObject<CProduct>* pProduct;	
	CURRENCY price;	
	HRESULT hr;	
	
	*aProduct = NULL;	
	hr = products.OpenProduct(sku); 	
	if ( SUCCEEDED(hr) ) {		
		hr = products.MoveFirst();		
		if ( SUCCEEDED(hr) ) {			
			hr = CComObject<CProduct>::CreateInstance(&pProduct);			
			if (SUCCEEDED(hr)){				
				pProduct->put_ProductSKU( products.m_SKU );				
				pProduct->put_Composer( SysAllocStringLen( (OLECHAR FAR*)products.m_COMPOSER, 21) );				
				pProduct->put_Composition( SysAllocString( (OLECHAR FAR*)products.m_COMPOSITION) );				
				pProduct->put_Conductor( SysAllocString( (OLECHAR FAR*)products.m_CONDUCTOR) );				
				pProduct->put_Description( SysAllocString( (OLECHAR FAR*)products.m_DESCRIPTION) );				
				pProduct->put_Image( SysAllocString( (OLECHAR FAR*)products.m_IMAGE) );				
				pProduct->put_Performer( SysAllocString( (OLECHAR FAR*)products.m_PERFORMER) );				
				VarCyFromR4(products.m_PRICE, &price);				
				pProduct->put_Price( price );				
				hr = pProduct->QueryInterface(IID_IProduct, reinterpret_cast<void**>(aProduct));
			}		
		}	
	}	
	return hr;
}

//##ModelId=37DC1C7D033E
STDMETHODIMP CProductInventory::AddProduct(IProduct* aProduct)
{
	// TODO: Add your implementation code here
	
	return S_OK;
}

//##ModelId=37DC1C7D0340
STDMETHODIMP CProductInventory::RemoveProduct(long sku)
{
	// TODO: Add your implementation code here
	
	return S_OK;
}

//##ModelId=37DC1C7D0342
STDMETHODIMP CProductInventory::UpdateProduct(IProduct* aProduct)
{
	// TODO: Add your implementation code here
	
	return S_OK;
}


