VERSION 5.00
Begin VB.UserControl ctlAmountDisplay 
   ClientHeight    =   1665
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5505
   ScaleHeight     =   1665
   ScaleWidth      =   5505
   Begin VB.Label lblDisplay 
      AutoSize        =   -1  'True
      Caption         =   "Press New to start a new sale transaction"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   5085
   End
End
Attribute VB_Name = "ctlAmountDisplay"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"37A5E32E0398"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"User Control"
'##ModelId=37A5E3410096
Private mAmount As Currency
'##ModelId=37A5E34100D2
Private pos As Integer

'##ModelId=37A5E34102F8
Public Event DisplayChanged(strAmount As String)

'##ModelId=37A5E3410104
Public Property Let Amount(aVal As Currency)
    mAmount = aVal
    lblDisplay.Caption = AsString
End Property

'##ModelId=37A5E3410141
Public Property Get Amount() As Currency
    Amount = mAmount
End Property

'##ModelId=37A5E3410172
Public Function AsString() As String
    AsString = FormatCurrency(mAmount)
End Function

'##ModelId=37A5E34101AE
Public Sub KeyPressed(aChar As String)
    Dim c As String ' the leftmost character of the string
    Dim v As Single ' the value in terms of a number
    
    If aChar = "00" Then
        If pos > -2 Then Amount = mAmount * 100
    Else
        c = Left(aChar, 1)
        If c = "0" Then
            If pos = -2 Then
                ' this key press is meaningless
            Else
                Amount = mAmount * 10 + v
                pos = pos + 1
            End If
        Else
            If c >= "1" And c <= "9" Then
                v = CSng(c) / 100
                If pos = -2 Then
                    Amount = v
                    pos = pos + 1
                Else
                    Amount = mAmount * 10 + v
                    pos = pos + 1
                End If
            End If
        End If
    End If
End Sub

'##ModelId=37A5E34101E0
Public Sub Increment(val As Currency)
    Amount = mAmount + val
End Sub

'##ModelId=37A5E341021C
Public Sub SetDecimal()
    ' reset the position to make it 0
    If pos = -1 Then
        Amount = Amount * 100
    End If
    pos = 0
End Sub

'##ModelId=37A5E341024E
Public Sub Clear()
    Amount = 0
    pos = -2
End Sub

'##ModelId=37A5E341024F
Public Sub DisplayMessage(msg As String)
    lblDisplay.Alignment = 0 ' left justify messages
    lblDisplay.Caption = msg
    RaiseEvent DisplayChanged(msg)
End Sub

'##ModelId=37A5E341028B
Private Sub UserControl_Initialize()
    mAmount = 0
    pos = -2
End Sub

'##ModelId=37A5E34102BC
Private Sub UserControl_Resize()
    lblDisplay.Left = 0
    lblDisplay.Top = 0
    lblDisplay.Width = Width
    lblDisplay.Height = Height
End Sub
