VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "POSTransaction"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"378A09A20122"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Class Module"
Option Explicit

'##ModelId=37B30B5F0280
Private mSalesLineItemID As Long
'##ModelId=37B30B5F0320
Private mTillID As Long
'##ModelId=37B30B600050
Private mCreated As Date
'##ModelId=37B30B6000F0
Private mPaymentMethodID As Long
'##ModelId=37B30B60019A
Private mCardHolder As String
'##ModelId=37B30B60023A
Private mCardNumber As String
'##ModelId=37B30B6002E4
Private mCardExpiration As String


'##ModelId=37B2F4FF0014
Private Property Get ISalesTransaction_SalesLineItemID() As Long
    ISalesTransaction_SalesLineItemID = mSalesLineItemID
End Property

'##ModelId=37B2F4FF0082
Private Property Let ISalesTransaction_SalesLineItemID(ByVal SalesLineItemID As Long)
    
End Property

'##ModelId=37B2F4FF015E
Private Property Get ISalesTransaction_TillID() As Long
    ISalesTransaction_TillID = mTillID
End Property

'##ModelId=37B2F4FF01FE
Private Property Let ISalesTransaction_TillID(ByVal TillID As Long)
    mTillID = TillID
End Property

'##ModelId=37B2F4FF02DA
Private Property Get ISalesTransaction_Created() As Date
    ISalesTransaction_Created = mCreated
End Property

'##ModelId=37B2F4FF0384
Private Property Let ISalesTransaction_Created(ByVal Created As Date)
    mCreated = Created
End Property

'##ModelId=37B2F5000078
Private Property Get ISalesTransaction_Total() As Currency
    ISalesTransaction_Total = total
End Property

'##ModelId=37B2F5000118
Private Property Let ISalesTransaction_Total(ByVal total As Currency)
    ' no can do here.
End Property

'##ModelId=37B2F5000230
Private Property Get ISalesTransaction_Tax() As Currency
    ISalesTransaction_Tax = Tax
End Property

'##ModelId=37B2F50002D0
Private Property Let ISalesTransaction_Tax(ByVal Tax As Currency)
    '## Your code goes here ...
End Property

'##ModelId=37B2F5010000
Private Property Get ISalesTransaction_SubTotal() As Currency
    ISalesTransaction_SubTotal = SubTotal
End Property

'##ModelId=37B2F50100A0
Private Property Let ISalesTransaction_SubTotal(ByVal SubTotal As Currency)
    '## Your code goes here ...
End Property

'##ModelId=37B2F50101B8
Private Property Get ISalesTransaction_PaymentMethodID() As Long
    ISalesTransaction_PaymentMethodID = mPaymentMethodID
End Property

'##ModelId=37B2F5010258
Private Property Let ISalesTransaction_PaymentMethodID(ByVal PaymentMethodID As Long)
    mPaymentMethodID = PaymentMethodID
End Property

'##ModelId=37B2F50103A2
Private Property Get ISalesTransaction_CardHolder() As String
    ISalesTransaction_CardHolder = mCardHolder
End Property

'##ModelId=37B2F5020064
Private Property Let ISalesTransaction_CardHolder(ByVal cardHolder As String)
    mCardHolder = cardHolder
End Property

'##ModelId=37B2F50201AE
Private Property Get ISalesTransaction_CardNumber() As String
    ISalesTransaction_CardNumber = mCardNumber
End Property

'##ModelId=37B2F502024E
Private Property Let ISalesTransaction_CardNumber(ByVal cardNumber As String)
    mCardNumber = cardNumber
End Property

'##ModelId=37B2F50203CA
Private Property Get ISalesTransaction_CardExpiration() As String
    ISalesTransaction_CardExpiration = mCardExpiration
End Property

'##ModelId=37B2F50300BE
Private Property Let ISalesTransaction_CardExpiration(ByVal cardExpiration As String)
    mCardExpiration = cardExpiration
End Property

'##ModelId=37B30B630366
Public Function ISalesTransaction_GetLineItemCount() As Long
    ISalesTransaction_GetLineItemCount = mLineItems.Count
End Function

'##ModelId=37B30B6303D4
Public Function ISalesTransaction_GetLineItem(index As Long) As ISalesLineItem
    Dim lineItem As ISalesLineItem
    Set lineItem = mLineItems.Item(index)
    Set ISalesTransaction_GetLineItem = lineItem
End Function

'##ModelId=37A5E91D014A
Public Function AddItem(aProduct As IProduct) As POSLineItem
    Dim lineItem As New POSLineItem
    
    Set lineItem.theProduct = aProduct
    
    mLineItems.Add lineItem
    Set AddItem = lineItem
End Function

'##ModelId=37B2BB5C00AB
Public Function Count() As Long
    Count = mLineItems.Count
End Function

'##ModelId=37A5E938008C
Public Sub RemoveItem(anIndex As Long)
    mLineItems.Remove anIndex
End Sub

'##ModelId=37A5E9450140
Public Function GetItem(anIndex As Long) As POSLineItem
    Set GetItem = mLineItems.Item(anIndex)
End Function

'##ModelId=37B2BB5C01B8
Public Function total() As Currency
    total = SubTotal + Tax
End Function

'##ModelId=37B2BB5C01EA
Public Function SubTotal() As Currency
    ' iterate
    Dim RunningTotal As Currency
    Dim lineItem As POSLineItem
    
    RunningTotal = 0
    For Each lineItem In mLineItems
        RunningTotal = RunningTotal + lineItem.total
    Next lineItem
    
    SubTotal = RunningTotal
    
End Function

'##ModelId=37B2BB5C01EB
Public Function Tax() As Currency
    ' the tax rate is measured in 100ths of dollar
    Tax = (SubTotal * TaxRate) / 100
End Function

'##ModelId=37B30B650050
Public Sub Payment(PaymentMethodID As Long, Optional cardHolder As String = "", Optional cardNumber As String = "", Optional cardExpiration As String = "")
    mPaymentMethodID = PaymentMethodID
    If cardHolder <> "" Then
        mCardHolder = cardHolder
        mCardNumber = cardNumber
        mCardExpiration = cardExpiration
    End If
End Sub

'##ModelId=37B1A1EA00DC
Public Sub Clear()
    Set mLineItems = New Collection
End Sub

'##ModelId=37B2BB5C0258
Private Sub Class_Initialize()
    Set mLineItems = New Collection
    mCreated = Now
End Sub
